#include <math.h>
#include "ranlib.h"
#include "header.h"


void generate_point(int t, int p){
  int u,points;
  double vector[UNDERLIERS];

  genmn(Parm, vector, Scratch);
  
  Price[t][0][p] = INITIAL*exp( vector[0]-t*VARIANCE/2.0);
  Price[t][1][p] = INITIAL*exp( vector[1]-t*VARIANCE/2.0);
  
  if(vector[0] > vector[1]){
    Max1[t][p] = 0;
    Max2[t][p] = 1;
  }else{
    Max1[t][p] = 1;
    Max2[t][p] = 0;
  }
  
  for(u=2;u<UNDERLIERS;++u){
    Price[t][u][p] = INITIAL*exp(vector[u]-t*VARIANCE/2.0);
    
    if(Price[t][u][p] > Price[t][ Max1[t][p] ][p] ){
      Max2[t][p] = Max1[t][p];
      Max1[t][p] = u;
    }else if(Price[t][u][p] > Price[t][ Max2[t][p] ][p] ){
      Max2[t][p] = u;
    }
  }

  Value_if_exercised[t][p] = exp(-t*INTEREST)*(Price[t][ Max1[t][p] ][p] - STRIKE);
  if(Price[t][ Max1[t][p] ][p] < 0) Price[t][ Max1[t][p] ][p] = 0;
}
